/***************************************************************************
 ** DEMO.C                                                                **
 ** By Brian Provinciano                                                  **
 ** Last compiled May 9th, 1999                                           **
 **                                                                       **
 ** Demonstrates how to use CUR2C                                         **
 ***************************************************************************/

#include<stdio.h>
#include<dos.h>

typedef unsigned char  byte;

byte *VGA=(byte *)0xA0000000L;        /* this points to video memory. */

void PlotPixel(int x,int y,byte color)   /* Plots pixels very quickly */
{
	VGA[y*320+x]=color;
}

void GraphMode()       /* Sets the screen to a 320x200 graphics mode */
{
	union REGS regs;
	struct SREGS sregs;

	regs.x.ax = 0x13;
	int86x(0x10, &regs, &regs, &sregs);
}

void EndGraph()     /* Sets the screen back to text mode */
{
	union REGS regs;
	struct SREGS sregs;

	regs.x.ax = 0x03;
	int86x(0x10, &regs, &regs, &sregs);
}

void ShowCursor()          /* Shows the mouse cursor */
{
	union REGS regs;
	struct SREGS sregs;

	regs.x.ax = 0x01;

	int86x(0x33, &regs, &regs, &sregs);

}

/* Set the mouse cursor to a custom one */
void SetMouseGraphicsCursor(int HotSpotX,int HotSpotY,void far * BitmapPtr)
{
	union REGS regs;
	struct SREGS sregs;

	regs.x.ax = 0x09;
	regs.x.bx = HotSpotX;
	regs.x.cx = HotSpotY;
	regs.x.dx = FP_OFF(BitmapPtr);
	sregs.es = FP_SEG(BitmapPtr);

	int86x(0x33, &regs, &regs, &sregs);

}

/* Begin program */
void main()
{
int x,y;

#include "cursor.c" /* Use the cursor gernerated by CUR2C */

GraphMode(); /* Sets the screen to graphics mode */


for (x = 0; x < 319; x++) {   /* This makes the background cyan so
											that the cursor shows up better */
	for (y = 16; y < 199; y++) {

		PlotPixel(x,y,3);

	}

}

	/* Prints a message */
	printf("  SCI Cursor -> C/C++ code Demo  v1.0\n          By Brian Provinciano");

	SetMouseGraphicsCursor(0,0,SCICursor); /* Sets the mouse cursor to the SCI one */
	ShowCursor(); /* Shows the mouse cursor */

	getch();  /* Wait for key */

	EndGraph(); /* Back to text mode */

}

/* End */
